Index: issm/branches/trunk-larour-NatGeoScience2016/test/NightlyRun/test229.py
===================================================================
--- issm/branches/trunk-larour-NatGeoScience2016/test/NightlyRun/test229.py	(revision 21243)
+++ issm/branches/trunk-larour-NatGeoScience2016/test/NightlyRun/test229.py	(revision 21759)
@@ -1,5 +1,6 @@
 #Test Name: SquareShelfTranForcePos2d
-import numpy
+import numpy as np
 from model import *
+from socket import gethostname
 from triangle import *
 from setmask import *
@@ -7,5 +8,5 @@
 from setflowequation import *
 from solve import *
-from MatlabFuncs import *
+
 
 md=triangle(model(),'../Exp/Square.exp',150000.)
@@ -13,5 +14,5 @@
 md=parameterize(md,'../Par/SquareShelf.py')
 md=setflowequation(md,'SSA','all')
-md.cluster=generic('name',oshostname(),'np',3)
+md.cluster=generic('name',gethostname(),'np',3)
 
 md.timestepping.time_step=1.
@@ -20,8 +21,8 @@
 
 #Set up transient
-smb=numpy.ones((md.mesh.numberofvertices,1))*3.6
-smb=numpy.hstack((smb,smb*2.))
+smb=np.ones((md.mesh.numberofvertices))*3.6
+smb=np.vstack((smb,smb*2.)).T
 
-md.smb.mass_balance=numpy.vstack((smb,[1.5,3.]))
+md.smb.mass_balance=np.vstack((smb,[1.5,3.]))
 md.transient.isthermal=False
 
@@ -29,44 +30,42 @@
 
 #Fields and tolerances to track changes
-field_names=['Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SmbMassBalance1', \
-	'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SmbMassBalance2', \
-	'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SmbMassBalance3', \
-	'Vx4','Vy4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SmbMassBalance4']
-field_tolerances=[1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,\
-	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,\
-	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,\
-	1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10]
-field_values=[\
-	md.results.TransientSolution[0].Vx,\
-	md.results.TransientSolution[0].Vy,\
-	md.results.TransientSolution[0].Vel,\
-	md.results.TransientSolution[0].Pressure,\
-	md.results.TransientSolution[0].Base,\
-	md.results.TransientSolution[0].Surface,\
-	md.results.TransientSolution[0].Thickness,\
-	md.results.TransientSolution[0].SmbMassBalance,\
-	md.results.TransientSolution[1].Vx,\
-	md.results.TransientSolution[1].Vy,\
-	md.results.TransientSolution[1].Vel,\
-	md.results.TransientSolution[1].Pressure,\
-	md.results.TransientSolution[1].Base,\
-	md.results.TransientSolution[1].Surface,\
-	md.results.TransientSolution[1].Thickness,\
-	md.results.TransientSolution[1].SmbMassBalance,\
-	md.results.TransientSolution[2].Vx,\
-	md.results.TransientSolution[2].Vy,\
-	md.results.TransientSolution[2].Vel,\
-	md.results.TransientSolution[2].Pressure,\
-	md.results.TransientSolution[2].Base,\
-	md.results.TransientSolution[2].Surface,\
-	md.results.TransientSolution[2].Thickness,\
-	md.results.TransientSolution[2].SmbMassBalance,\
-	md.results.TransientSolution[3].Vx,\
-	md.results.TransientSolution[3].Vy,\
-	md.results.TransientSolution[3].Vel,\
-	md.results.TransientSolution[3].Pressure,\
-	md.results.TransientSolution[3].Base,\
-	md.results.TransientSolution[3].Surface,\
-	md.results.TransientSolution[3].Thickness,\
-	md.results.TransientSolution[3].SmbMassBalance,\
-	]
+field_names=['Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SmbMassBalance1',
+						 'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SmbMassBalance2',
+						 'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SmbMassBalance3',
+						 'Vx4','Vy4','Vel4','Pressure4','Bed4','Surface4','Thickness4','SmbMassBalance4']
+field_tolerances=[1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,
+									1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,
+									1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10,
+									1e-09,1e-09,1e-10,1e-10,1e-10,1e-10,1e-10,1e-10]
+field_values=[md.results.TransientSolution[0].Vx,
+							md.results.TransientSolution[0].Vy,
+							md.results.TransientSolution[0].Vel,
+							md.results.TransientSolution[0].Pressure,
+							md.results.TransientSolution[0].Base,
+							md.results.TransientSolution[0].Surface,
+							md.results.TransientSolution[0].Thickness,
+							md.results.TransientSolution[0].SmbMassBalance,
+							md.results.TransientSolution[1].Vx,
+							md.results.TransientSolution[1].Vy,
+							md.results.TransientSolution[1].Vel,
+							md.results.TransientSolution[1].Pressure,
+							md.results.TransientSolution[1].Base,
+							md.results.TransientSolution[1].Surface,
+							md.results.TransientSolution[1].Thickness,
+							md.results.TransientSolution[1].SmbMassBalance,
+							md.results.TransientSolution[2].Vx,
+							md.results.TransientSolution[2].Vy,
+							md.results.TransientSolution[2].Vel,
+							md.results.TransientSolution[2].Pressure,
+							md.results.TransientSolution[2].Base,
+							md.results.TransientSolution[2].Surface,
+							md.results.TransientSolution[2].Thickness,
+							md.results.TransientSolution[2].SmbMassBalance,
+							md.results.TransientSolution[3].Vx,
+							md.results.TransientSolution[3].Vy,
+							md.results.TransientSolution[3].Vel,
+							md.results.TransientSolution[3].Pressure,
+							md.results.TransientSolution[3].Base,
+							md.results.TransientSolution[3].Surface,
+							md.results.TransientSolution[3].Thickness,
+							md.results.TransientSolution[3].SmbMassBalance]