Index: issm/trunk-jpl/src/c/analyses/LevelsetAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/LevelsetAnalysis.cpp	(revision 22190)
+++ issm/trunk-jpl/src/c/analyses/LevelsetAnalysis.cpp	(revision 22192)
@@ -60,5 +60,5 @@
 			iomodel->FetchDataToInput(elements,"md.calving.meltingrate",CalvinglevermannMeltingrateEnum);
 			break;
-		case CalvingDevEnum:
+		case CalvingVonmisesEnum:
 			iomodel->FetchDataToInput(elements,"md.calving.stress_threshold_groundedice",CalvingStressThresholdGroundediceEnum);
 			iomodel->FetchDataToInput(elements,"md.calving.stress_threshold_floatingice",CalvingStressThresholdFloatingiceEnum);
@@ -89,5 +89,5 @@
 		case DefaultCalvingEnum:
 		case CalvingLevermannEnum:
-		case CalvingDevEnum:
+		case CalvingVonmisesEnum:
 			break;
 		case CalvingMinthicknessEnum:
@@ -220,5 +220,5 @@
 	switch(calvinglaw){
 		case DefaultCalvingEnum:
-		case CalvingDevEnum:
+		case CalvingVonmisesEnum:
 			lsf_slopex_input  = basalelement->GetInput(LevelsetfunctionSlopeXEnum); _assert_(lsf_slopex_input);
 			if(dim==2) lsf_slopey_input  = basalelement->GetInput(LevelsetfunctionSlopeYEnum); _assert_(lsf_slopey_input);
@@ -291,5 +291,5 @@
 		switch(calvinglaw){
 			case DefaultCalvingEnum:
-			case CalvingDevEnum:
+			case CalvingVonmisesEnum:
 				lsf_slopex_input->GetInputValue(&dlsf[0],gauss);
 				if(dim==2) lsf_slopey_input->GetInputValue(&dlsf[1],gauss);
Index: issm/trunk-jpl/src/c/classes/Elements/Element.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Element.cpp	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/Elements/Element.cpp	(revision 22192)
@@ -2353,6 +2353,6 @@
 					this->CalvingRateLevermann();
 					break;
-				case CalvingDevEnum:
-					this->CalvingRateDev();
+				case CalvingVonmisesEnum:
+					this->CalvingRateVonmises();
 					break;
 				case CalvingCrevasseDepthEnum:
@@ -2366,5 +2366,5 @@
 		case StrainRateperpendicularEnum: this->StrainRateperpendicular(); break;
 		case SurfaceCrevasseEnum: this->CalvingCrevasseDepth(); break;
-		case SigmaVMEnum: this->CalvingRateDev(); break;
+		case SigmaVMEnum: this->CalvingRateVonmises(); break;
 	}
 
Index: issm/trunk-jpl/src/c/classes/Elements/Element.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Element.h	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/Elements/Element.h	(revision 22192)
@@ -188,5 +188,5 @@
 		virtual void       AverageOntoPartition(Vector<IssmDouble>* partition_contributions,Vector<IssmDouble>* partition_areas,IssmDouble* vertex_response,IssmDouble* qmu_part)=0;
 		virtual void		 BasalNodeIndices(int* pnumindices,int** pindices,int finiteelement){_error_("not implemented yet");};
-		virtual void       CalvingRateDev(void){_error_("not implemented yet");};
+		virtual void       CalvingRateVonmises(void){_error_("not implemented yet");};
 		virtual void       CalvingCrevasseDepth(void){_error_("not implemented yet");};
 		virtual void	    CalvingRateLevermann(void)=0;
Index: issm/trunk-jpl/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 22192)
@@ -182,5 +182,5 @@
 }
 /*}}}*/
-void       Penta::CalvingRateDev(){/*{{{*/
+void       Penta::CalvingRateVonmises(){/*{{{*/
 
 	if(!this->IsOnBase()) return;
Index: issm/trunk-jpl/src/c/classes/Elements/Penta.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Penta.h	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/Elements/Penta.h	(revision 22192)
@@ -49,5 +49,5 @@
 		void           AverageOntoPartition(Vector<IssmDouble>* partition_contributions,Vector<IssmDouble>* partition_areas,IssmDouble* vertex_response,IssmDouble* qmu_part);
 		void           BasalNodeIndices(int* pnumindices,int** pindices,int finiteelement);
-		void           CalvingRateDev();
+		void           CalvingRateVonmises();
 		void           CalvingRateLevermann();
 		IssmDouble     CharacteristicLength(void){_error_("not implemented yet");};
Index: issm/trunk-jpl/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Tria.cpp	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/Elements/Tria.cpp	(revision 22192)
@@ -208,5 +208,5 @@
 }
 /*}}}*/
-void       Tria::CalvingRateDev(){/*{{{*/
+void       Tria::CalvingRateVonmises(){/*{{{*/
 
 	IssmDouble  xyz_list[NUMVERTICES][3];
Index: issm/trunk-jpl/src/c/classes/Elements/Tria.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Tria.h	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/Elements/Tria.h	(revision 22192)
@@ -52,5 +52,5 @@
 		/*Element virtual functions definitions: {{{*/
 		void        AverageOntoPartition(Vector<IssmDouble>* partition_contributions,Vector<IssmDouble>* partition_areas,IssmDouble* vertex_response,IssmDouble* qmu_part);
-		void			CalvingRateDev();
+		void			CalvingRateVonmises();
 		void        CalvingCrevasseDepth();
 		void			CalvingRateLevermann();
Index: issm/trunk-jpl/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/FemModel.cpp	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/FemModel.cpp	(revision 22192)
@@ -920,9 +920,9 @@
 
 }/*}}}*/
-void FemModel::CalvingRateDevx(){/*{{{*/
+void FemModel::CalvingRateVonmisesx(){/*{{{*/
 
 	for(int i=0;i<elements->Size();i++){
 		Element* element=dynamic_cast<Element*>(this->elements->GetObjectByOffset(i));
-		element->CalvingRateDev();
+		element->CalvingRateVonmises();
 	}
 }
Index: issm/trunk-jpl/src/c/classes/FemModel.h
===================================================================
--- issm/trunk-jpl/src/c/classes/FemModel.h	(revision 22190)
+++ issm/trunk-jpl/src/c/classes/FemModel.h	(revision 22192)
@@ -82,5 +82,5 @@
 		/*Modules*/ 
 		void BalancethicknessMisfitx(IssmDouble* pV);
-		void CalvingRateDevx();
+		void CalvingRateVonmisesx();
 		void CalvingRateLevermannx();
 		void DeviatoricStressx();
Index: issm/trunk-jpl/src/c/modules/Calvingx/Calvingx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/Calvingx/Calvingx.cpp	(revision 22190)
+++ issm/trunk-jpl/src/c/modules/Calvingx/Calvingx.cpp	(revision 22192)
@@ -31,7 +31,7 @@
 			femmodel->CalvingRateLevermannx();
 			break;
-		case CalvingDevEnum:
-			femmodel->CalvingRateDevx();
-			femmodel->ElementOperationx(&Element::CalvingRateDev);
+		case CalvingVonmisesEnum:
+			femmodel->CalvingRateVonmisesx();
+			femmodel->ElementOperationx(&Element::CalvingRateVonmises);
 			break;
 		default:
Index: issm/trunk-jpl/src/m/classes/calvingdev.m
===================================================================
--- issm/trunk-jpl/src/m/classes/calvingdev.m	(revision 22190)
+++ 	(revision )
@@ -1,63 +1,0 @@
-%CALVINGDEV class definition
-%
-%   Usage:
-%      calvingdev=calvingdev();
-
-classdef calvingdev
-	properties (SetAccess=public) 
-		stress_threshold_groundedice = 0.;
-		stress_threshold_floatingice = 0.;
-		meltingrate   = NaN;
-	end
-	methods
-		function self = calvingdev(varargin) % {{{
-			switch nargin
-				case 0
-					self=setdefaultparameters(self);
-				case 1
-					inputstruct=varargin{1};
-					list1 = properties('calvingdev');
-					list2 = fieldnames(inputstruct);
-					for i=1:length(list1)
-						fieldname = list1{i};
-						if ismember(fieldname,list2),
-							self.(fieldname) = inputstruct.(fieldname);
-						end
-					end
-				otherwise
-					error('constructor not supported');
-			end
-		end % }}}
-		function self = extrude(self,md) % {{{
-			self.meltingrate=project3d(md,'vector',self.meltingrate,'type','node');
-		end % }}}
-		function self = setdefaultparameters(self) % {{{
-
-			%Default sigma max
-			self.stress_threshold_groundedice = 1e6;
-			self.stress_threshold_floatingice = 150e3;
-		end % }}}
-		function md = checkconsistency(self,md,solution,analyses) % {{{
-			%Early return
-			if (~strcmp(solution,'TransientSolution') | md.transient.ismovingfront==0), return; end
-
-			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'nan',1,'Inf',1);
-			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'nan',1,'Inf',1);
-			md = checkfield(md,'fieldname','calving.meltingrate','NaN',1,'Inf',1,'timeseries',1,'>=',0);
-		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   Calving Pi parameters:'));
-			fielddisplay(self,'stress_threshold_groundedice','sigma_max applied to grounded ice only [Pa]');
-			fielddisplay(self,'stress_threshold_floatingice','sigma_max applied to floating ice only [Pa]');
-			fielddisplay(self,'meltingrate','melting rate at given location [m/a]');
-
-		end % }}}
-		function marshall(self,prefix,md,fid) % {{{
-			yts=md.constants.yts;
-			WriteData(fid,prefix,'name','md.calving.law','data',2,'format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','stress_threshold_groundedice','format','DoubleMat','mattype',1);
-			WriteData(fid,prefix,'object',self,'fieldname','stress_threshold_floatingice','format','DoubleMat','mattype',1);
-			WriteData(fid,prefix,'object',self,'fieldname','meltingrate','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1./yts);
-		end % }}}
-	end
-end
Index: issm/trunk-jpl/src/m/classes/calvingvonmises.m
===================================================================
--- issm/trunk-jpl/src/m/classes/calvingvonmises.m	(revision 22192)
+++ issm/trunk-jpl/src/m/classes/calvingvonmises.m	(revision 22192)
@@ -0,0 +1,63 @@
+%CALVINGVONMISES class definition
+%
+%   Usage:
+%      calvingvonmises=calvingvonmises();
+
+classdef calvingvonmises
+	properties (SetAccess=public) 
+		stress_threshold_groundedice = 0.;
+		stress_threshold_floatingice = 0.;
+		meltingrate   = NaN;
+	end
+	methods
+		function self = calvingvonmises(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				case 1
+					inputstruct=varargin{1};
+					list1 = properties('calvingvonmises');
+					list2 = fieldnames(inputstruct);
+					for i=1:length(list1)
+						fieldname = list1{i};
+						if ismember(fieldname,list2),
+							self.(fieldname) = inputstruct.(fieldname);
+						end
+					end
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+			self.meltingrate=project3d(md,'vector',self.meltingrate,'type','node');
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+
+			%Default sigma max
+			self.stress_threshold_groundedice = 1e6;
+			self.stress_threshold_floatingice = 150e3;
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+			%Early return
+			if (~strcmp(solution,'TransientSolution') | md.transient.ismovingfront==0), return; end
+
+			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'nan',1,'Inf',1);
+			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'nan',1,'Inf',1);
+			md = checkfield(md,'fieldname','calving.meltingrate','NaN',1,'Inf',1,'timeseries',1,'>=',0);
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   Calving VonMises parameters:'));
+			fielddisplay(self,'stress_threshold_groundedice','sigma_max applied to grounded ice only [Pa]');
+			fielddisplay(self,'stress_threshold_floatingice','sigma_max applied to floating ice only [Pa]');
+			fielddisplay(self,'meltingrate','melting rate at given location [m/a]');
+
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+			yts=md.constants.yts;
+			WriteData(fid,prefix,'name','md.calving.law','data',2,'format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','stress_threshold_groundedice','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','stress_threshold_floatingice','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','meltingrate','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1./yts);
+		end % }}}
+	end
+end